using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Logging;
using SlnMesnac.Business.@base;
using SlnMesnac.Common;
using SlnMesnac.Config;
using SlnMesnac.Model.domain;
using SlnMesnac.Model.dto;
using SlnMesnac.Model.enums;
using SlnMesnac.Plc;
using SlnMesnac.Repository.service;
using SlnMesnac.Rfid;
using SlnMesnac.TouchSocket;
using SqlSugar;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Threading.Tasks;
using TouchSocket.Core;
using static System.Net.Mime.MediaTypeNames;

#region <<   ע  >>
/*--------------------------------------------------------------------
* Ȩ (c) 2024 WenJY Ȩ
* CLR汾4.0.30319.42000
* ƣLAPTOP-E0N2L34V
* ռ䣺SlnMesnac.Business
* Ψһʶf79d6d97-d9b0-4b0b-a442-e6bb1c1c79e6
*
* ߣWenJY
* 䣺wenjy@mesnac.com
* ʱ䣺2024-04-10 16:36:01
* 汾V1.0.0
* 
*
*--------------------------------------------------------------------
* ޸ˣ
* ʱ䣺
* ޸˵
*
* 汾V1.0.0
*--------------------------------------------------------------------*/
#endregion <<   ע  >>
namespace SlnMesnac.Business
{
    /// <summary>
    /// 豸ҵ߼
    /// </summary>
    public class ProdCompletionBusiness : BaseBusiness
    {
        private FJ500Comm.FJ500SP fj500s = new FJ500Comm.FJ500SP();
        //ʧܻ豸״̬Դ
        private int PmTryAmount = 0;
        //ÿյظˢʱ䣬1ӣΪϿӣһ
        private DateTime PmHeartTime = DateTime.Now;
        private readonly IMesProductPlanService _mesProductPlanService;
        private readonly IMesProductOrderService _mesProductOrderService;
        private readonly IMesPrdBarCodeService _barCodeTaskService;
        private readonly IBaseMaterialInfoService _baseMaterialInfoService;
        private readonly IMesBaseBarcodeInfoService _mesBaseBarcodeInfoService;
        public readonly IMesPrdBarCodeService _mesPrdBarCodeService;
        private readonly IRealPalletTaskService _realPalletTaskService;
        private readonly UdpServer udpServer;
        private DebugConfig debugConfig = DebugConfig.Instance;
        private ISqlSugarClient sqlSugarClient;

        public ProdCompletionBusiness(ISqlSugarClient _sqlSugarClient, ILogger<BaseBusiness> logger, AppConfig appConfig, List<PlcAbsractFactory> plcFactories, List<RfidAbsractFactory> rfidFactories, IMesProductPlanService mesProductPlanService, IMesPrdBarCodeService barCodeTaskService, IServiceProvider serviceProvider) : base(logger, appConfig, plcFactories, rfidFactories, serviceProvider)
        {
            udpServer = serviceProvider.GetRequiredService<UdpServer>();
            UdpServer.ReceivedPMCodeEvent += PmCodeHandler;
            sqlSugarClient = _sqlSugarClient;
            _mesProductPlanService = mesProductPlanService;
            _barCodeTaskService = barCodeTaskService;
            _realPalletTaskService = serviceProvider.GetRequiredService<IRealPalletTaskService>();
            _mesBaseBarcodeInfoService = serviceProvider.GetRequiredService<IMesBaseBarcodeInfoService>();
            _mesPrdBarCodeService = serviceProvider.GetRequiredService<IMesPrdBarCodeService>();
            _mesProductOrderService = serviceProvider.GetRequiredService<IMesProductOrderService>();
            _baseMaterialInfoService = serviceProvider.GetRequiredService<IBaseMaterialInfoService>();
            Init();

        }

        private void test()
        {
           
            // MesProductPlanDetail? mesProductPlanDetail = sqlSugarClient.AsTenant().GetConnection("mes").Queryable<MesProductPlanDetail>().First(x => x.PlanCode == "20240724144533JL001");
            //sqlSugarClient.AsTenant().BeginTran();
            //string epc = "JYHB01010102";
            //_mesProductPlanService.GetStartedProdPlan(out MesProductPlanDto productPlanDto);
            //string bigCode = GenerateBigBarcode(productPlanDto, epc);
            //BindingBarCode(bigCode, epc, productPlanDto);
            //sqlSugarClient.AsTenant().BeginTran();
        }


        private static bool isEmptyPalletHandleRunning = false;
        public void Init()
        {

            Task.Run(async () =>
           {
               await EmptyPalletHandle();

           });
            Task.Run(() =>
            {
                DeviceOutPutHandle();
            });

            //豸״̬
            checkPmStatus();
        }

        #region 豸ͨѶ
        /// <summary>
        /// ״̬
        /// </summary>
        public void checkPmStatus()
        {
            PmTryAmount++;
            Task.Run(() =>
            {
                while (true)
                {
                    try
                    {
                        //ͼ״ָ̬
                       // udpServer.SendMessage(fj500s.CheckState());
                       // Thread.Sleep(1000 * 5);
                        // ·ʹӡ룬֤ʼ
                        SendFirstPmCode();

                    }
                    catch (Exception ex)
                    {
                        _logger.LogError("checkStatus쳣:" + ex.Message);
                    }
                    Thread.Sleep(1000 * 30);

                    if (DateTime.Now - PmHeartTime > TimeSpan.FromMinutes(2))
                    {
                        //
                        _logger.LogError("====================ͨѶʧԤͱ");
                        AddAlarm(WarnStatusEnum.豸״̬ϻӡʧԤ30);
                        PmTryAmount++;
                    }
                }
            });
        }



        /// <summary>
        /// Ϣ
        /// 1.ɼ
        /// 2.״̬
        /// </summary>
        /// <param name="str"></param>
        private void PmCodeHandler(string str)
        {
            PmHeartTime = DateTime.Now;
            try
            {
                int LastTryAmount = PmTryAmount;
                var result = fj500s.GetAck(str);
                if (result == "00")
                {
                    // ݳɹ
                    _logger.LogInformation("====================յݳɹ");
                    PmTryAmount = 0;
                }
                else if (result == "0E")
                {
                    // 豸
                    _logger.LogError($"====================յ豸״̬ϻӡʧԤ,Դ:{PmTryAmount}");
                    PmTryAmount++;
                   
                    if (PmTryAmount <= 30)
                    {
                        //·
                        Task.Run(() =>
                        {
                            Thread.Sleep(1000 * 5);
                            SendFirstPmCode();
                        });
                    }
                    else
                    {
                        _logger.LogError("====================30Σͱ");
                        AddAlarm(WarnStatusEnum.豸״̬ϻӡʧԤ30);
                    }

                }
                else if (result == "0F")
                {
                    _logger.LogInformation("====================յӡɣһӡ");
                    updatePrdBarcodeInfo();
                    SendFirstPmCode();
                    _logger.LogInformation("====================һӡɹ");
                    PmTryAmount = 0;
                }

                if (LastTryAmount>0 && PmTryAmount==0)
                { // 
                    _logger.LogInformation("");
                    deleteAlarm(WarnStatusEnum.豸״̬ϻӡʧԤ30);
                }

            }
            catch (Exception ex)
            {
                _logger.LogError("PmCodeHandlerظϢ쳣:" + ex.Message);
            }
        }

        /// <summary>
        /// ȡݿδӡδ
        /// </summary>
        private void SendFirstPmCode()
        {
            MesPrdBarcodeInfo mesPrdBarcodeInfo = _barCodeTaskService.Query(x => x.PrintFlag == "0" && x.BindStatus == 0).OrderBy(x => x.PrdBarcodeId).FirstOrDefault();
            if(mesPrdBarcodeInfo != null)
            {
                udpServer.SendMessage(mesPrdBarcodeInfo.PrdBarcodeInfo);
            }
            else
            {
                _logger.LogError("㣬ԭ");
            }
           
        }

        /// <summary>
        /// ӡɸ
        /// </summary>
        private void updatePrdBarcodeInfo()
        {
            MesPrdBarcodeInfo mesPrdBarcodeInfo = _barCodeTaskService.Query(x => x.PrintFlag == "0" && x.BindStatus == 0).OrderBy(x => x.PrdBarcodeId).FirstOrDefault();
            mesPrdBarcodeInfo.PrintFlag = "1";
            mesPrdBarcodeInfo.PrintTime = DateTime.Now;
            _barCodeTaskService.Update(mesPrdBarcodeInfo);
        }

        #endregion
        
        
        /// <summary>
        /// 豸߼
        /// </summary>
        private async void DeviceOutPutHandle()
        {
            // ȡRFIDʧԴ5ͱ
            int readRfidAmount = 0;
            while (true)
            {
                try
                {
                    var plc = base.GetPlcByKey("plc");

                    if (plc == null)
                    {
                        _logger.LogInformation("ȡСź,PLCϢΪ......");
                        Thread.Sleep(3000);
                        continue;
                    }
                    // plc.writeStringByAddress(GetPlcAddressByConfigKey("2¥RFIDַ"), "JYHB01010125", 12);


                    if (!plc.readBoolByAddress(GetPlcAddressByConfigKey("2¥Сڵλź")))
                    {
                        _logger.LogInformation("ȴСźŴ......");
                        Thread.Sleep(5000);
                        continue;
                    }

                    string rfid = plc.readStringByAddress(GetPlcAddressByConfigKey("2¥RFIDַ"), 12).Replace("\0", "");

                    if (!string.IsNullOrWhiteSpace(rfid))
                    {
                        _logger.LogInformation("СѾRFIDˣٶ");
                        Thread.Sleep(5000);
                        continue;
                    }

                    string epcStr = await ReadEpcStrByRfidKeyAsync("secondFloorOut");
                    if (string.IsNullOrEmpty(epcStr))
                    {
                        _logger.LogError("СڵλźŴ,ȡRFIDʧ......");
                        //жǰһλǷ̻
                        RealPalletTask realPalletTask = _realPalletTaskService.Query().FirstOrDefault();
                        if (realPalletTask != null)
                        {
                            epcStr = realPalletTask.PalletCode;
                        }
                        else
                        {
                            readRfidAmount++;
                            if (readRfidAmount == 5)
                            {
                                string virtualEpc = NoReadRFIDAlarm();
                                _logger.LogError("СڵλźŴ,ȡRFIDʧܳ5......");
                                //if (!string.IsNullOrEmpty(virtualEpc))
                                //{
                                //    //TODU ̺Ҫϵͳ洢
                                //    epcStr = virtualEpc;
                                //    _logger.LogError("СڵλźŴ,ȡRFIDʧܳ5,̺:" + virtualEpc);
                                //}
                                Thread.Sleep(1000 * 5);
                                continue;
                            }
                            else
                            {
                                Thread.Sleep(1000 * 5);
                                continue;
                            }

                        }
                    }

                    // УepcǷѾڿеĻ¶


                    var hasLocation  = sqlSugarClient.AsTenant().GetConnection("mes").Queryable<BaseLocation>().Where(x => x.ContainerCode == epcStr).First();
                    if (hasLocation != null)
                    {
                        _logger.LogError("СڵλźŴ,ȡRFIDʧ,epcѾڿ:" + epcStr);
                        Thread.Sleep(5000);
                        continue;
                    }

                    RefreshMessage($"СڶȡRFID{epcStr},ʼ:");

                    _mesProductPlanService.GetStartedProdPlan(out MesProductPlanDto productPlanDto);
                    if (productPlanDto == null)
                    {
                       
                        //throw new ArgumentException($"δȡִеƻ");

                        //޼ƻʱ޼ƻMaterialId޸ģļ
                        productPlanDto = new MesProductPlanDto();
                        productPlanDto.PlanCode = "0";
                        productPlanDto.MaterialId = long.Parse(debugConfig.MaterialId);
                        productPlanDto.SaleOrderId =  0;
                        productPlanDto.SaleorderCode =  "0";
                    }
                    #region 
                    sqlSugarClient.AsTenant().BeginTran();
                    //1.ɴmes_barcode_info
                    string bigCode = GenerateBigBarcode(productPlanDto, epcStr);
                    //2.40С뼰̺ţС󶨴,̰󶨴
                    BindingBarCode(bigCode, epcStr, productPlanDto);
                    //3.mes_product_planmes_product_order
                    UpdatePlanInfoAndOrder(productPlanDto);


                    // ɾʹõݿ̺
                    List<RealPalletTask> realPalletList = _realPalletTaskService.Query(x => x.PalletCode == epcStr);
                    if (realPalletList != null && realPalletList.Count > 0)
                    {
                        sqlSugarClient.AsTenant().GetConnection("mes").Deleteable(realPalletList).ExecuteCommand();
                    }
                    // дPLC RFIDŹʹ
                    plc.writeStringByAddress(GetPlcAddressByConfigKey("2¥RFIDַ"), epcStr, 12);
                    // plc.writeByteByAddress(GetPlcAddressByConfigKey("2¥Сڵλź"), 2);
                    readRfidAmount = 0;
                    sqlSugarClient.AsTenant().CommitTran();
                    #endregion
                }
                catch (Exception ex)
                {
                    sqlSugarClient.AsTenant().RollbackTran();

                    _logger.LogError($"DeviceOutPutHandle쳣:{ex.Message}");
                }

                Thread.Sleep(1000 * 5);
            }
        }
      
        /// <summary>
        /// ɴmes_barcode_info
        /// </summary>
        /// <param name="productPlanDto"></param>
        /// <param name="epcStr"></param>
        /// <returns></returns>
        private string GenerateBigBarcode(MesProductPlanDto productPlanDto, string epcStr)
        {

            string bigBarcode = productPlanDto.PlanCode + DateTime.Now.ToString("_MMddHHmmss");
            MesBaseBarcodeInfo mesBaseBarcodeInfo = new MesBaseBarcodeInfo();
            mesBaseBarcodeInfo.printTime = DateTime.Now;
            mesBaseBarcodeInfo.printPerson = "SlnMesnac";
            mesBaseBarcodeInfo.printFlag = "1";
            mesBaseBarcodeInfo.batchFlag = "0";
            mesBaseBarcodeInfo.barcodeType = "3";
            mesBaseBarcodeInfo.barcodeInfo = bigBarcode;
            mesBaseBarcodeInfo.batchCode = bigBarcode;
            mesBaseBarcodeInfo.palletInfoCode = epcStr;
            mesBaseBarcodeInfo.materialId = productPlanDto.MaterialId;
            mesBaseBarcodeInfo.amount = 1;
            mesBaseBarcodeInfo.printNumber = 1;
            mesBaseBarcodeInfo.productionDate = DateTime.Now;
            mesBaseBarcodeInfo.acceptedDate = DateTime.Now;
            mesBaseBarcodeInfo.planCode = productPlanDto.PlanCode;
            MesProductPlanDetail? mesProductPlanDetail = sqlSugarClient.AsTenant().GetConnection("mes").Queryable<MesProductPlanDetail>().First(x => x.PlanCode == productPlanDto.PlanCode);
            if (mesProductPlanDetail != null)
            {
                mesBaseBarcodeInfo.planDetailCode = mesProductPlanDetail.PlanDetailCode;
            }
            mesBaseBarcodeInfo.safeFlag = productPlanDto.SaleOrderId == 0 ? "1" : "0";
            mesBaseBarcodeInfo.saleOrderId = productPlanDto.SaleOrderId;
            mesBaseBarcodeInfo.saleorderCode = productPlanDto.SaleorderCode;
            mesBaseBarcodeInfo.bindStatus = "1";
            mesBaseBarcodeInfo.bindTime = DateTime.Now;
            mesBaseBarcodeInfo.updateBy = "SlnMesnac";
            mesBaseBarcodeInfo.updateTime = DateTime.Now;
            mesBaseBarcodeInfo.completeFlag = "1";
            mesBaseBarcodeInfo.singleFlag = "0";
            var materialInfo = _baseMaterialInfoService.Query(x => x.MaterialId == productPlanDto.MaterialId).FirstOrDefault();
            if (materialInfo != null)
            {
                mesBaseBarcodeInfo.barcodeSpec = materialInfo.MaterialSpec;
            }
            sqlSugarClient.AsTenant().GetConnection("mes").Insertable(mesBaseBarcodeInfo).ExecuteCommand();
            return bigBarcode;
        }

        /// <summary>
        /// 40С뼰̺ţС󶨴
        /// </summary>
        /// <param name="bigBarcode"></param>
        /// <param name="epcStr"></param>
        private void BindingBarCode(string bigBarcode, string epcStr, MesProductPlanDto productPlanDto)
        {
            List<MesPrdBarcodeInfo> list = _mesPrdBarCodeService.GetUseBarCodeList();
            if (list == null || list.Count == 0)
            {
                throw new InvalidOperationException("δҵ԰󶨵С");
            }

            if (list.Where(x => x.PrintFlag == "1").ToList().Count < 40)
            {
                // ͵ͼ𱨾
                AddAlarm(WarnStatusEnum.̰ʱ40);
            }
            foreach (var item in list)
            {
                item.PalletInfoCode = epcStr;
                item.MesBarcodeInfo = bigBarcode;
                item.BindTime = DateTime.Now;
                item.BindStatus = 1;
            }
            sqlSugarClient.AsTenant().GetConnection("mes").Updateable(list).ExecuteCommand();

            //̰󶨴Ϣ
            BasePalletInfo palletInfo = sqlSugarClient.AsTenant().GetConnection("mes").Queryable<BasePalletInfo>().Where(x => x.PalletInfoCode == epcStr).First();
            if (palletInfo != null)
            {
                palletInfo.MaterialBarcode = bigBarcode;
                palletInfo.MaterialId = productPlanDto.MaterialId;
            }
            sqlSugarClient.AsTenant().GetConnection("mes").Updateable(palletInfo).ExecuteCommand();

        }

        private void UpdatePlanInfoAndOrder(MesProductPlanDto productPlanDto)
        {
            MesProductPlan productPlan = _mesProductPlanService.Query(x => x.PlanCode == productPlanDto.PlanCode).FirstOrDefault();
            if (productPlan == null)
            {
                _logger.LogInformation("δҵƻӦ!,޹¼ƻ");
                return;
            }
            MesProductOrder productOrder = _mesProductOrderService.Query(x => x.ProductOrderId == productPlan.ProductOrderId).FirstOrDefault();
            if (productPlan == null)
            {
                _logger.LogInformation("δҵƻӦ!,޹¼ƻ");
                return;
            }
            #region ƻ
            if (productPlan.CompleteAmount == 0)
            {
                productPlan.RealBeginTime = DateTime.Now;
            }
            productPlan.CompleteAmount++;
            if (productPlan.CompleteAmount == productPlan.PlanAmount)
            {

                productPlan.RealEndTime = DateTime.Now;
                productPlan.PlanStatus = Model.enums.PlanStatusEnum.;
            }
            productPlan.UpdateTime = DateTime.Now;
            productPlan.UpdateBy = "SlnMesnac";
            sqlSugarClient.AsTenant().GetConnection("mes").Updateable(productPlan).ExecuteCommand();
            #endregion

            #region 

            if (productOrder.CompleteAmount == 0)
            {

                productOrder.RealBeginTime = DateTime.Now;
            }
            productOrder.CompleteAmount++;
            if (productOrder.CompleteAmount == productOrder.PlanAmount)
            {

                productOrder.RealEndTime = DateTime.Now;
                productOrder.OrderStatus = "2";
            }
            productOrder.UpdateTime = DateTime.Now;
            productOrder.UpdateBy = "SlnMesnac";
            sqlSugarClient.AsTenant().GetConnection("mes").Updateable(productOrder).ExecuteCommand();
            #endregion

        }


        #region 
        /// <summary>
        /// 
        /// 뱨
        /// </summary>
        private void AddAlarm(WarnStatusEnum warnStatusEnum)
        {
            try
            {
                sqlSugarClient.AsTenant().BeginTran();

                // бҳ豸ı¼ûб¼߱¼ѽ¼
                int warnRuleId = int.Parse(warnStatusEnum.GetDescription());
                DmsRecordAlarmTime? dmsRecordAlarmTime = sqlSugarClient.AsTenant().GetConnection("mes").Queryable<DmsRecordAlarmTime>().First(x => x.AlarmRuleId == warnRuleId);
                if (dmsRecordAlarmTime == null)
                {
                    DmsBaseAlarmRule dmsBaseAlarmRule = sqlSugarClient.AsTenant().GetConnection("mes").Queryable<DmsBaseAlarmRule>().First(x => x.AlarmRuleId == warnRuleId);

                    dmsRecordAlarmTime = new DmsRecordAlarmTime();
                    dmsRecordAlarmTime.DeviceId = dmsBaseAlarmRule.DeviceId;
                    dmsRecordAlarmTime.AlarmRuleId = warnRuleId;
                    dmsRecordAlarmTime.AlarmBeginTime = DateTime.Now;
                    dmsRecordAlarmTime.ContinueTime = dmsBaseAlarmRule.ContinueTime;
                    dmsRecordAlarmTime.AlarmReason = dmsBaseAlarmRule.AlarmReason;
                    dmsRecordAlarmTime.AlarmReason = dmsBaseAlarmRule.AlarmReason;
                    dmsRecordAlarmTime.AlarmData = warnStatusEnum.ToString();
                    dmsRecordAlarmTime.HandleSuggest = dmsBaseAlarmRule.HandleSuggest;
                    dmsRecordAlarmTime.CreateBy = "SlnMesnac";
                    dmsRecordAlarmTime.CreateTime = DateTime.Now;

                    DmsRecordAlarmInfo dmsRecordAlarmInfo = new DmsRecordAlarmInfo();
                    dmsRecordAlarmInfo.DeviceId = dmsBaseAlarmRule.DeviceId;
                    dmsRecordAlarmInfo.AlarmRuleId = warnRuleId;
                    dmsRecordAlarmInfo.AlarmBeginTime = DateTime.Now;
                    dmsRecordAlarmInfo.AlarmStatus = "0";
                    dmsRecordAlarmInfo.NoticeStatus = "0";
                    dmsRecordAlarmInfo.ContinueTime = dmsBaseAlarmRule.ContinueTime;
                    dmsRecordAlarmInfo.AlarmReason = dmsBaseAlarmRule.AlarmReason;
                    dmsRecordAlarmInfo.AlarmReason = dmsBaseAlarmRule.AlarmReason;
                    dmsRecordAlarmInfo.AlarmData = warnStatusEnum.ToString();
                    dmsRecordAlarmInfo.HandleSuggest = dmsBaseAlarmRule.HandleSuggest;
                    dmsRecordAlarmInfo.CreateBy = "SlnMesnac";
                    dmsRecordAlarmInfo.CreateTime = DateTime.Now;

                    sqlSugarClient.AsTenant().GetConnection("mes").Insertable(dmsRecordAlarmTime).ExecuteCommand();
                    sqlSugarClient.AsTenant().GetConnection("mes").Insertable(dmsRecordAlarmInfo).ExecuteCommand();
                }
                else
                {

                    dmsRecordAlarmTime.UpdateTime = DateTime.Now;
                    dmsRecordAlarmTime.UpdateBy = "SlnMesnac";
                    DmsRecordAlarmInfo dmsRecordAlarmInfo = sqlSugarClient.AsTenant().GetConnection("mes").Queryable<DmsRecordAlarmInfo>().First(x => x.AlarmRuleId == warnRuleId);
                    if (dmsRecordAlarmInfo != null)
                    {
                        dmsRecordAlarmInfo.UpdateTime = DateTime.Now;
                        dmsRecordAlarmInfo.UpdateBy = "SlnMesnac";
                        sqlSugarClient.AsTenant().GetConnection("mes").Updateable(dmsRecordAlarmInfo).ExecuteCommand();
                    }
                    else
                    {
                        DmsBaseAlarmRule dmsBaseAlarmRule = sqlSugarClient.AsTenant().GetConnection("mes").Queryable<DmsBaseAlarmRule>().First(x => x.AlarmRuleId == warnRuleId);

                        dmsRecordAlarmInfo = new DmsRecordAlarmInfo();
                        dmsRecordAlarmInfo.DeviceId = dmsRecordAlarmTime.DeviceId;
                        dmsRecordAlarmInfo.AlarmRuleId = warnRuleId;
                        dmsRecordAlarmInfo.AlarmBeginTime = DateTime.Now;
                        dmsRecordAlarmInfo.AlarmStatus = "0";
                        dmsRecordAlarmInfo.NoticeStatus = "0";
                        dmsRecordAlarmInfo.ContinueTime = dmsBaseAlarmRule.ContinueTime;
                        dmsRecordAlarmInfo.AlarmReason = dmsBaseAlarmRule.AlarmReason;
                        dmsRecordAlarmInfo.AlarmReason = dmsBaseAlarmRule.AlarmReason;
                        dmsRecordAlarmInfo.AlarmData = warnStatusEnum.ToString();
                        dmsRecordAlarmInfo.HandleSuggest = dmsBaseAlarmRule.HandleSuggest;
                        dmsRecordAlarmInfo.CreateBy = "SlnMesnac";
                        dmsRecordAlarmInfo.CreateTime = DateTime.Now;
                        sqlSugarClient.AsTenant().GetConnection("mes").Insertable(dmsRecordAlarmInfo).ExecuteCommand();
                    }

                    sqlSugarClient.AsTenant().GetConnection("mes").Updateable(dmsRecordAlarmTime).ExecuteCommand();

                }

                sqlSugarClient.AsTenant().CommitTran();

            }
            catch (Exception ex)
            {
                sqlSugarClient.AsTenant().RollbackTran();
                _logger.LogError($"߸±Ϣ쳣{warnStatusEnum.ToString()} ==>:{ex.Message}");

            }

        }

        /// <summary>
        /// 
        /// </summary>
        /// <exception cref="InvalidOperationException"></exception>
        private void deleteAlarm(WarnStatusEnum warnStatusEnum)
        {

            DmsRecordAlarmTime? dmsRecordAlarmTime = sqlSugarClient.AsTenant().GetConnection("mes").Queryable<DmsRecordAlarmTime>().First(x => x.AlarmRuleId == long.Parse(warnStatusEnum.GetDescription()));
            if (dmsRecordAlarmTime != null)
            {
                sqlSugarClient.AsTenant().BeginTran();
                DmsRecordAlarmInfo dmsRecordAlarmInfo = sqlSugarClient.AsTenant().GetConnection("mes").Queryable<DmsRecordAlarmInfo>().First(x => x.AlarmRuleId == dmsRecordAlarmTime.AlarmRuleId && x.AlarmStatus == "0");
                if (dmsRecordAlarmInfo != null)
                {
                    dmsRecordAlarmInfo.AlarmEndTime = DateTime.Now;
                    dmsRecordAlarmInfo.AlarmStatus = "2";
                    dmsRecordAlarmInfo.UpdateTime = DateTime.Now;
                    sqlSugarClient.AsTenant().GetConnection("mes").Updateable(dmsRecordAlarmInfo).ExecuteCommand();
                }
                sqlSugarClient.AsTenant().GetConnection("mes").Deleteable(dmsRecordAlarmTime).ExecuteCommand();

                sqlSugarClient.AsTenant().CommitTran();
            }
        }

        /// <summary>
        /// ͱ,̺ʱʹã̺Ŵ浽Ϣ˹Խ̺滻Ϊ̺
        /// <return> ̺
        /// </summary>
        private string NoReadRFIDAlarm()
        {
            string epcStr;
            try
            {
                epcStr = "TEMP" + DateTime.Now.ToString("MMddHHmm");
                sqlSugarClient.AsTenant().BeginTran();

                // бҳ豸ı¼ûб¼߱¼ѽ¼
                int warnRuleId = int.Parse(WarnStatusEnum.СڶȡRFIDʧ5.GetDescription());
                DmsRecordAlarmTime? dmsRecordAlarmTime = sqlSugarClient.AsTenant().GetConnection("mes").Queryable<DmsRecordAlarmTime>().First(x => x.AlarmRuleId == warnRuleId);
                if (dmsRecordAlarmTime == null)
                {
                    DmsBaseAlarmRule dmsBaseAlarmRule = sqlSugarClient.AsTenant().GetConnection("mes").Queryable<DmsBaseAlarmRule>().First(x => x.AlarmRuleId == warnRuleId);

                    dmsRecordAlarmTime = new DmsRecordAlarmTime();
                    dmsRecordAlarmTime.DeviceId = dmsBaseAlarmRule.DeviceId;
                    dmsRecordAlarmTime.AlarmRuleId = warnRuleId;
                    dmsRecordAlarmTime.AlarmBeginTime = DateTime.Now;
                    dmsRecordAlarmTime.ContinueTime = dmsBaseAlarmRule.ContinueTime;
                    dmsRecordAlarmTime.AlarmReason = dmsBaseAlarmRule.AlarmReason;
                    dmsRecordAlarmTime.AlarmReason = dmsBaseAlarmRule.AlarmReason;
                    dmsRecordAlarmTime.AlarmData = WarnStatusEnum.СڶȡRFIDʧ5.ToString();
                    dmsRecordAlarmTime.HandleSuggest = dmsBaseAlarmRule.HandleSuggest + ";;̺Ϊ:" + epcStr;
                    dmsRecordAlarmTime.CreateBy = "SlnMesnac";
                    dmsRecordAlarmTime.CreateTime = DateTime.Now;

                    DmsRecordAlarmInfo dmsRecordAlarmInfo = new DmsRecordAlarmInfo();
                    dmsRecordAlarmInfo.DeviceId = dmsBaseAlarmRule.DeviceId;
                    dmsRecordAlarmInfo.AlarmRuleId = warnRuleId;
                    dmsRecordAlarmInfo.AlarmBeginTime = DateTime.Now;
                    dmsRecordAlarmInfo.AlarmStatus = "0";
                    dmsRecordAlarmInfo.NoticeStatus = "0";
                    dmsRecordAlarmInfo.ContinueTime = dmsBaseAlarmRule.ContinueTime;
                    dmsRecordAlarmInfo.AlarmReason = dmsBaseAlarmRule.AlarmReason;
                    dmsRecordAlarmInfo.AlarmReason = dmsBaseAlarmRule.AlarmReason;
                    dmsRecordAlarmInfo.AlarmData = WarnStatusEnum.СڶȡRFIDʧ5.ToString();
                    dmsRecordAlarmInfo.HandleSuggest = dmsBaseAlarmRule.HandleSuggest + ";;̺Ϊ:" + epcStr;
                    dmsRecordAlarmInfo.CreateBy = "SlnMesnac";
                    dmsRecordAlarmInfo.CreateTime = DateTime.Now;

                    sqlSugarClient.AsTenant().GetConnection("mes").Insertable(dmsRecordAlarmTime).ExecuteCommand();
                    sqlSugarClient.AsTenant().GetConnection("mes").Insertable(dmsRecordAlarmInfo).ExecuteCommand();
                }
                else
                {

                    dmsRecordAlarmTime.UpdateTime = DateTime.Now;
                    dmsRecordAlarmTime.UpdateBy = "SlnMesnac";
                    DmsRecordAlarmInfo dmsRecordAlarmInfo = sqlSugarClient.AsTenant().GetConnection("mes").Queryable<DmsRecordAlarmInfo>().First(x => x.AlarmRuleId == warnRuleId);
                    if (dmsRecordAlarmInfo != null)
                    {
                        dmsRecordAlarmInfo.UpdateTime = DateTime.Now;
                        dmsRecordAlarmInfo.UpdateBy = "SlnMesnac";
                    }
                    sqlSugarClient.AsTenant().GetConnection("mes").Updateable(dmsRecordAlarmTime).ExecuteCommand();
                    sqlSugarClient.AsTenant().GetConnection("mes").Updateable(dmsRecordAlarmInfo).ExecuteCommand();

                }

                sqlSugarClient.AsTenant().CommitTran();
                return epcStr;
            }
            catch (Exception ex)
            {
                sqlSugarClient.AsTenant().RollbackTran();
                _logger.LogError($"NoReadRFIDAlarm쳣:{ex.Message}");
                return "";
            }

        }


       
        #endregion


        /// <summary>
        /// ̽λ,ȡRFID
        /// </summary>
        private async Task EmptyPalletHandle()
        {
            //ȡPLCתź
            while (true)
            {
                try
                {
                    var plc = base.GetPlcByKey("plc");
                    if (plc == null)
                    {
                        _logger.LogInformation("ȡPLC⵽λź,PLCϢΪ......");
                        Thread.Sleep(5000);
                        continue;
                    }
                    if (!plc.readBoolByAddress(GetPlcAddressByConfigKey("2¥⵽λź")))
                    {
                        _logger.LogInformation("ȴ̵λźŴ......");
                        Thread.Sleep(5000);
                        continue;
                    }

                    RealPalletTask realPalletTask = _realPalletTaskService.Query().FirstOrDefault();
                    if (realPalletTask != null)
                    {
                        _logger.LogInformation("̵λźŴ,Ѿжȡ̣ٶȡ......");
                        Thread.Sleep(5000);
                        continue;
                    }

                    //ȡRFIDȡǰִеļƻǰƻϢ̰
                    RefreshMessage("̵λźŴɹ,ȡRFIDϢ");

                    string epcStr = await ReadEpcStrByRfidKeyAsync("secondFloorPallet");

                    if (string.IsNullOrEmpty(epcStr))
                    {
                        _logger.LogError("̵λźŴ,ȡRFIDʧ......");
                        Thread.Sleep(1000 * 10);
                        continue;
                    }

                    RefreshMessage($"RFIDϢȡɹǩϢ{epcStr}");

                    // һ̼¼
                    realPalletTask = new RealPalletTask()
                    {
                        PalletCode = epcStr,
                        RecordTime = DateTime.Now,
                    };
                    _realPalletTaskService.Insert(realPalletTask);

                }
                catch (Exception e)
                {
                    RefreshMessage($"̽λ쳣{e.Message}");
                }
                Thread.Sleep(1000 * 10);
            }
        }


        /// <summary>
        /// ȡ
        /// </summary>
        /// <param name="barCode"></param>
        /// <param name="result"></param>
        /// <exception cref="InvalidOperationException"></exception>
        private void ExtractNumber(string barCode, out int result)
        {
            string pattern = @"\b0*(\d{1,6})\b$";

            Match match = Regex.Match(barCode, pattern);
            if (match.Success)
            {
                result = Convert.ToInt32(match.Groups[1].Value) + 1;
            }
            else
            {
                throw new InvalidOperationException($"ͨ:{barCode}ȡǰ쳣:δҵƥ");
            }
        }

    }
}
